import { Extension, EditorState } from "@codemirror/next/state";
import { KeyBinding } from "@codemirror/next/view";
import { CompletionContext, Completion, CompletionSource } from "./completion";
import { CompletionConfig } from "./config";
import { SnippetSpec } from "./snippet";
export { snippet, SnippetSpec } from "./snippet";
export { Completion, CompletionContext, CompletionSource, CompletionResult } from "./completion";
export { startCompletion, closeCompletion, acceptCompletion, moveCompletionSelection } from "./view";
export declare function autocompletion(config?: CompletionConfig): Extension;
export declare const completionKeymap: readonly KeyBinding[];
export declare function completeFromList(list: readonly (string | Completion)[]): CompletionSource;
export declare function ifNotIn(nodes: readonly string[], source: CompletionSource): (context: CompletionContext) => import("./completion").CompletionResult | Promise<import("./completion").CompletionResult | null> | null;
export declare function completeSnippets(snippets: readonly SnippetSpec[]): CompletionSource;
export declare function completionStatus(state: EditorState): null | "active" | "pending";
export declare function currentCompletions(state: EditorState): readonly Completion[];
//# sourceMappingURL=index.d.ts.map