import { LezerLanguage } from "@codemirror/next/language";
import { Extension } from "@codemirror/next/state";
import { Completion } from "@codemirror/next/autocomplete";
declare type SQLDialectSpec = {
    keywords?: string;
    builtin?: string;
    types?: string;
    backslashEscapes?: boolean;
    hashComments?: boolean;
    slashComments?: boolean;
    spaceAfterDashes?: boolean;
    doubleQuotedStrings?: boolean;
    charSetCasts?: boolean;
    operatorChars?: string;
    specialVar?: string;
    identifierQuotes?: string;
};
export declare class SQLDialect {
    readonly language: LezerLanguage;
    get extension(): Extension;
    static define(spec: SQLDialectSpec): SQLDialect;
}
export declare type SQLConfig = {
    dialect?: SQLDialect;
    schema?: {
        [table: string]: readonly (string | Completion)[];
    };
    tables?: readonly Completion[];
    defaultTable?: string;
};
export declare function keywordCompletion(dialect: SQLDialect): Extension;
export declare function schemaCompletion(config: SQLConfig): Extension;
export declare function sqlSupport(config: SQLConfig): Extension;
export declare function sql(config: SQLConfig): Extension;
export declare const StandardSQL: SQLDialect;
export declare const PostgreSQL: SQLDialect;
export declare const MySQL: SQLDialect;
export declare const MariaSQL: SQLDialect;
export declare const MSSQL: SQLDialect;
export declare const SQLite: SQLDialect;
export declare const Cassandra: SQLDialect;
export declare const PLSQL: SQLDialect;
export {};
//# sourceMappingURL=sql.d.ts.map