import { NodeProp } from "lezer-tree";
import { Language, IndentContext } from "@codemirror/next/language";
import { StringStream } from "./stringstream";
export { StringStream };
export declare type StreamParser<State> = {
    token(stream: StringStream, state: State): string | null;
    blankLine?(state: State): void;
    startState?(): State;
    copyState?(state: State): State;
    indent?(state: State, textAfter: string, context: IndentContext): number | null;
    docProps?: readonly [NodeProp<any>, any][];
    languageData?: {
        [name: string]: any;
    };
};
export declare class StreamLanguage<State> extends Language {
    private constructor();
    static define<State>(spec: StreamParser<State>): StreamLanguage<State>;
    private getIndent;
}
//# sourceMappingURL=stream-parser.d.ts.map